
#include <cstdio>
#include <vector>

using namespace std;

void dfs(int cur, vector<bool> &reached,
				 vector<int> &count,vector<vector<int> > &edges){
	if(reached[cur]) return;
	reached[cur] = true;
	count[cur]++;
	for(int i=0;i<edges[cur].size();i++)
		dfs(edges[cur][i], reached, count, edges);
}

int main(void){
	int k,n,m;
	scanf("%d %d %d", &k, &n, &m);
	vector<int> ps(k);
	for(int i=0;i<k;i++){
		scanf("%d", &ps[i]);
		ps[i]--;
	}
	vector<vector<int> > edges(n);
	for(int i=0;i<m;i++){
		int a,b;
		scanf("%d %d", &a, &b);
		edges[a-1].push_back(b-1);
	}
	vector<int> count(n,0);
	for(int i=0;i<k;i++){
		vector<bool> reached(n, false);
		dfs(ps[i],reached, count, edges);
	}
	int ans = 0;
	for(int i=0;i<n;i++)
		if(count[i] == k)
			ans++;
	printf("%d\n",ans);
	return 0;
}
